#!/usr/bin/env make -f

#-------------------------------------------------------------------------------
# Config variables
#
# PACKAGE_{ID,RESOURCES} should be the same but "path" but formated differently.
# PACKAGE_ID has dots: org.example.app while...
# PACKAGE_RESOURCES has slashes: /org/example/app
#
# PACKAGE_RESOURCES MUST START WITH A SLASH (/), NOT END IN A SLASH (/) AND NOT
# CONTAIN A DOUBLE SLASH (//). Also no funcky characters.
#-------------------------------------------------------------------------------
PACKAGE = boilerplate-for-c-and-gtk3
PACKAGE_ID = io.github.julianrichen.boilerplate
PACKAGE_NAME = Boilerplate for C and GTK3
PACKAGE_RESOURCES = /io/github/julianrichen/boilerplate

#PACKAGE = app
#PACKAGE_ID = org.example.app
#PACKAGE_NAME = app by example.org
#PACKAGE_RESOURCES = /org/example/app

PACKAGE_VERSION_MAJOR = 0
PACKAGE_VERSION_MINOR = 1
PACKAGE_VERSION_MICRO = 0
PACKAGE_VERSION = $(PACKAGE_VERSION_MAJOR).$(PACKAGE_VERSION_MINOR).$(PACKAGE_VERSION_MICRO)

PACKAGE_COPYRIGHT = Copyright \xc2\xa9 2017 Julian Richen

PACKAGE_SUMMARY = A boilerplate for quick GTK3 development in C

PACKAGE_AUTHOR = Julian Richen
PACKAGE_EMAIL = julian@richen.io

PACKAGE_URL_HOMEPAGE = https://github.com/julianrichen/boilerplate-for-c-gtk3
PACKAGE_URL_DOCS = https://github.com/julianrichen/boilerplate-for-c-gtk3/wiki
PACKAGE_URL_BUGS = https://github.com/julianrichen/boilerplate-for-c-gtk3/issues

GETTEXT_PACKAGE = $(PACKAGE)

#-------------------------------------------------------------------------------
# Custom gen_vars function
#
# Looks for @VARIABLE@ and replaces it with $(VARIABLE)
#
# Usage:
#     $(call gen_vars,[input],[output])
# Example:
#     $(call gen_vars,$<,$@)
#-------------------------------------------------------------------------------
define gen_vars
	@$(SED) \
	-e "s|\@PACKAGE\@|$(PACKAGE)|" \
	-e "s|\@PACKAGE_ID\@|$(PACKAGE_ID)|" \
	-e "s|\@PACKAGE_NAME\@|$(PACKAGE_NAME)|" \
	-e "s|\@PACKAGE_RESOURCES\@|$(PACKAGE_RESOURCES)|" \
	-e "s|\@PACKAGE_VERSION_MAJOR\@|$(PACKAGE_VERSION_MAJOR)|" \
	-e "s|\@PACKAGE_VERSION_MINOR\@|$(PACKAGE_VERSION_MINOR)|" \
	-e "s|\@PACKAGE_VERSION_MICRO\@|$(PACKAGE_VERSION_MICRO)|" \
	-e "s|\@PACKAGE_VERSION\@|$(PACKAGE_VERSION)|" \
	-e "s|\@PACKAGE_COPYRIGHT\@|$(PACKAGE_COPYRIGHT)|" \
	-e "s|\@PACKAGE_SUMMARY\@|$(PACKAGE_SUMMARY)|" \
	-e "s|\@PACKAGE_AUTHOR\@|$(PACKAGE_AUTHOR)|" \
	-e "s|\@PACKAGE_EMAIL\@|$(PACKAGE_EMAIL)|" \
	-e "s|\@PACKAGE_URL_HOMEPAGE\@|$(PACKAGE_URL_HOMEPAGE)|" \
	-e "s|\@PACKAGE_URL_DOCS\@|$(PACKAGE_URL_DOCS)|" \
	-e "s|\@PACKAGE_URL_BUGS\@|$(PACKAGE_URL_BUGS)|" \
	-e "s|\@GETTEXT_PACKAGE\@|$(GETTEXT_PACKAGE)|" \
	$(1) > $(2)
	@echo SED on $(1) to $(2)
endef
