#define G_LOG_DOMAIN "boilerplate-preference"

#include "config.h"

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "boilerplate-application.h"
#include "boilerplate-window.h"
#include "boilerplate-preferences.h"

typedef struct
{
    BoilerplateWindow *window;
    GSettings *settings;
} BoilerplatePreferencesPrivate;

struct _BoilerplatePreferences
{
    GtkWindow parent_instance;
};

//TODO: Implement Preferences
//          General clean-up
//          Search feature
//          Pref description
//          Fix switch alignment
G_DEFINE_TYPE_WITH_PRIVATE (BoilerplatePreferences, boilerplate_preferences, GTK_TYPE_WINDOW)

static gboolean
_on_key_press (GtkWidget   *widget,
               GdkEventKey *event,
               gpointer     user_data) {
    switch (event->keyval)
    {
        case GDK_KEY_Escape:
            //TODO: Check for focus on search field
            // event->state & GDK_SHIFT_MASK
            // event->state & GDK_CONTROL_MASK
            gtk_widget_destroy (widget);
            return TRUE;
            break;

        default:
            return FALSE;
    }

    return FALSE;
}

static void
_on_search (GtkEntry          *entry,
            BoilerplateWindow *window)
{
  /*
  ExampleAppWindowPrivate *priv;
  const gchar *text;
  GtkWidget *tab;
  GtkWidget *view;
  GtkTextBuffer *buffer;
  GtkTextIter start, match_start, match_end;

  text = gtk_entry_get_text (entry);

  if (text[0] == '\0')
    return;

  priv = example_app_window_get_instance_private (win);

  tab = gtk_stack_get_visible_child (GTK_STACK (priv->stack));
  view = gtk_bin_get_child (GTK_BIN (tab));
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));

  gtk_text_buffer_get_start_iter (buffer, &start);
  if (gtk_text_iter_forward_search (&start, text, GTK_TEXT_SEARCH_CASE_INSENSITIVE,
                                    &match_start, &match_end, NULL))
    {
      gtk_text_buffer_select_range (buffer, &match_start, &match_end);
      gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (view), &match_start,
                                    0.0, FALSE, 0.0, 0.0);
    }
  */
}

static void
_update_preference_example_combo () {

}

static void
_update_preference_csd () {

}

static void
_update_preference_dark () {

}

static void
boilerplate_preferences_dispose (GObject *object)
{
    BoilerplatePreferencesPrivate *priv;

    priv = boilerplate_preferences_get_instance_private (BOILERPLATE_PREFERENCES (object));
    g_clear_object (&priv->settings);

    G_OBJECT_CLASS (boilerplate_preferences_parent_class)->dispose (object);
}

static void
boilerplate_preferences_class_init (BoilerplatePreferencesClass *class)
{
    G_OBJECT_CLASS (class)->dispose = boilerplate_preferences_dispose;

    gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (class),
                                                 PACKAGE_RESOURCES "/ui/preferences.ui");

    gtk_widget_class_bind_template_callback (GTK_WIDGET_CLASS (class), _on_search);

    /*
    gtk_widget_class_bind_template_child_private (GTK_WIDGET_CLASS (class), BoilerplatePreferences, font);
    gtk_widget_class_bind_template_child_private (GTK_WIDGET_CLASS (class), BoilerplatePreferences, transition);
    */
}

static void
boilerplate_preferences_init (BoilerplatePreferences *preferences)
{
    // BoilerplateApplication *application = BOILERPLATE_APPLICATION (g_application_get_default ());
    BoilerplatePreferencesPrivate *priv;

    priv = boilerplate_preferences_get_instance_private (preferences);
    gtk_widget_init_template (GTK_WIDGET (preferences));

    /* Connect escape key */
    g_signal_connect (G_OBJECT (preferences),
                      "key_press_event",
                      G_CALLBACK (_on_key_press),
                      NULL);

    //priv->settings = g_settings_new (PACKAGE_ID);

    /*
    g_settings_bind (priv->settings, "font",
                     priv->font, "dark-theme",
                     G_SETTINGS_BIND_DEFAULT);

    g_settings_bind (priv->settings, "transition",
                     priv->transition, "active-id",
                     G_SETTINGS_BIND_DEFAULT);
    */
}

BoilerplatePreferences *
boilerplate_preferences_new (BoilerplateWindow *window)
{
    return g_object_new (BOILERPLATE_TYPE_PREFERENCES,
                         "transient-for", window,
                         NULL);
}
